<?php
/*
==========================================================
ExpressionEngine - by pMachine - www.pmachine.com
Copyright (c) 2003-2006 pMachine, Inc.
==========================================================
File: pi.urlsafe.php
----------------------------------------------------------
Purpose: 
Make string URL safe like EE does on publish page, 
or the reverse
==========================================================
Version History:
1.0.2 - Jan 09 2007 - Fixed 'And' to be '&amp;'
1.0.1 - Dec 28 2006 - Added optional 'reverse' parameter
1.0.0 - Dec 28 2006 - Made into ExpressionEngine plugin
===========================================================
*/

$plugin_info = array(
						'pi_name'			=> 'URL Safe',
						'pi_version'			=> '1.0.2 - 20070109',
						'pi_author'			=> 'Ryan Masuga',
						'pi_author_url'		=> 'http://www.masugadesign.com/',
						'pi_description'		=> 'Makes a string url safe. Or the reverse.',
						'pi_usage'			=> Urlsafe::usage()
					);

class Urlsafe {

var $separator = "";
var $reverse = "";
var $old = "";
var $new = "";


var $return_data ="";
var $thetext ="";
var $newtext ="";
	
	
	function urlsafe () 
	{
			global $TMPL;
			
			$separator = $TMPL->fetch_param('separator'); //OPTIONAL - Defaults to '-'
			$reverse = $TMPL->fetch_param('reverse'); //OPTIONAL - Defaults to 'no'
			$thetext = $TMPL->tagdata;
			
			if ($separator == ""){$separator = "-";}
			if ($reverse == ""){$reverse = "no";}
				
				
				//$newtext = strtolower($thetext);
				
				if ($reverse == "yes") {
				
				$old = array("-","_");
				$new = array(" ",", ");
				
				$newtext = strtoupper(str_replace($old, $new, $thetext));
				
				
				// have to do the following to get commas to work correctly
				$phase1 = ucwords(strtolower($newtext));
				$this->return_data = str_replace("And", "&amp;", $phase1);
				

			} else {
				
				$this->return_data = strtolower(preg_replace(array("/(?:^[^a-zA-Z0-9_-]+|[^a-zA-Z0-9_-]+$)/", "/[^a-zA-Z0-9_-]+/"), array("", "$separator"), $thetext));
				
			 
			
			
				
			} 
			 // if (strlen($TMPL->tagdata) > $max) {
			 //  $leave = $max - strlen ($rep);
			 // 	$this->return_data = substr_replace($TMPL->tagdata, $rep, $leave);
			 // } else {
			 // 	$this->return_data = $TMPL->tagdata;
			 // }






	}
    
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------

// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
This is a pretty basic plugin. Underscores are replaced with a comma and a space, and hyphens are replaced with spaces.

Place the following tag in any of your templates:

{exp:urlsafe}Sides, Soups, Salads{/exp:urlsafe}
Returns: sides-soups-salads

{exp:urlsafe reverse="yes"}sides_soups_salads{/exp:urlsafe}
Returns: Sides, Soups, Salads

{exp:urlsafe reverse="yes"}sides-soups-salads{/exp:urlsafe}
Returns: Sides Soups Salads

PARAMETERS: 
The tag has two (optional) parameters:

1. separator: The replacement character [OPTIONAL, defaults to hyphen '-']
2. reverse: makes a url safe string in to a capitalized string [OPTIONAL]


<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
// END

}
?>